# ITU Operating Agency Table Parser

The ITU does not appear to publish a machine-readable list of Operating Agencies (except for the dropdown menus in SpaceCap).

To assist automatic ingestion of ITU filing data, this PHP script parses a text dump from the ITU-published PDF file 
PREFACE_EN.pdf ("PREFACE TO THE BR INTERNATIONAL FREQUENCY INFORMATION CIRCULAR (TERRESTRIAL SERVICES)")
and generates a properly-formatted CSV of every Operating Agency (and its Administration) discovered.

The script fetch_and_convert.sh will automatically download the latest PREFACE_EN.pdf directly from the ITU website
(this file is updated regularly), then convert it to a CSV.
